/*****************************************************************************/
/* Count-zero compte les bits  zro (pas trs utile)                        */
/* Copyright (C) 2005 Christian Mauduit (ufoot@ufoot.org)                    */
/*                                                                           */
/* This program is free software; you can redistribute it and/or modify      */
/* it under the terms of the GNU General Public License as published by      */
/* the Free Software Foundation; either version 2 of the License, or         */
/* (at your option) any later version.                                       */
/*                                                                           */
/* This program is distributed in the hope that it will be useful,           */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             */
/* GNU General Public License for more details.                              */
/*                                                                           */
/* You should have received a copy of the GNU General Public License         */
/* along with this program; if not, write to the Free Software               */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
/*                                                                           */
/* http://www.quoiqueux.org                                                  */
/*****************************************************************************/

#include <stdio.h>
#include <gmp.h>

#define NOCTET 256
#define ZEROS_ONLY

void init_bits_a_zero_par_octet(int tab[NOCTET]) {
  int i;

  for (i=0;i<NOCTET;++i) {
    tab[i]=(
	    ((i & 0x01) ? 0 : 1) +
	    ((i & 0x02) ? 0 : 1) +
	    ((i & 0x04) ? 0 : 1) +
	    ((i & 0x08) ? 0 : 1) +
	    ((i & 0x10) ? 0 : 1) +
	    ((i & 0x20) ? 0 : 1) +
	    ((i & 0x40) ? 0 : 1) +
	    ((i & 0x80) ? 0 : 1)
	    );
  }
}

void count_zeros_and_ones(mpz_t zeros, mpz_t ones) {
  int bits_a_zero_par_octet[NOCTET];
  int c;  
  int z;

  init_bits_a_zero_par_octet(bits_a_zero_par_octet);
  while ((c=getc(stdin)) != EOF) {
    z=bits_a_zero_par_octet[c];
    mpz_add_ui(zeros,zeros,z);
#ifndef ZEROS_ONLY
    mpz_add_ui(ones,ones,8-z);
#endif
  }
}

int main(int argc, char *argv[]) {
  mpz_t zeros;
  mpz_t ones;

  mpz_init(zeros);
  mpz_init(ones);
  count_zeros_and_ones(zeros,ones);
  mpz_out_str (stdout,10,zeros);
#ifndef ZEROS_ONLY
  printf(" ");
  mpz_out_str (stdout,10,ones);
#endif
  printf("\n");
  mpz_clear(zeros);
  mpz_clear(ones);

  return 0;
}
